diff --git src/VBox/Runtime/Makefile.kmk src/VBox/Runtime/Makefile.kmk
index b015047..a5806fd 100644
--- src/VBox/Runtime/Makefile.kmk
+++ src/VBox/Runtime/Makefile.kmk
@@ -1047,6 +1047,75 @@ RuntimeR3_SOURCES.freebsd = \
 	r3/posix/tls-posix.cpp \
 	r3/posix/utf8-posix.cpp
 
+## @todo Make BSD sched, implement RTMP*.
+RuntimeR3_SOURCES.netbsd = \
+	generic/cdrom-generic.cpp \
+	generic/RTDirQueryInfo-generic.cpp \
+	generic/RTDirSetTimes-generic.cpp \
+	generic/RTFileMove-generic.cpp \
+	generic/RTLogWriteDebugger-generic.cpp \
+ 	generic/RTSemEventMultiWait-2-ex-generic.cpp \
+ 	generic/RTSemEventMultiWaitNoResume-2-ex-generic.cpp \
+	generic/RTSystemQueryDmiString-generic.cpp \
+	generic/RTSystemShutdown-generic.cpp \
+	generic/RTThreadGetAffinity-stub-generic.cpp \
+	generic/RTThreadSetAffinity-stub-generic.cpp \
+	generic/RTThreadSetAffinityToCpu-generic.cpp \
+	generic/RTTimeLocalNow-generic.cpp \
+	generic/RTTimerCreate-generic.cpp \
+	generic/RTUuidCreate-generic.cpp \
+	generic/mppresent-generic.cpp \
+	generic/sched-generic.cpp \
+	generic/utf16locale-generic.cpp \
+	generic/uuid-generic.cpp \
+	generic/RTMpCpuId-generic.cpp \
+	generic/RTMpGetCoreCount-generic.cpp \
+	generic/RTMpGetOnlineCoreCount-generic.cpp \
+	generic/RTProcDaemonize-generic.cpp \
+	generic/RTProcIsRunningByName-generic.cpp \
+	generic/RTThreadGetNativeState-generic.cpp \
+	r3/netbsd/rtProcInitExePath-netbsd.cpp \
+	r3/generic/allocex-r3-generic.cpp \
+	r3/posix/RTFileQueryFsSizes-posix.cpp \
+	r3/posix/RTHandleGetStandard-posix.cpp \
+	r3/posix/RTMemProtect-posix.cpp \
+	r3/posix/RTPathUserHome-posix.cpp \
+	r3/posix/RTSystemQueryOSInfo-posix.cpp \
+	r3/posix/RTSystemQueryTotalRam-posix.cpp \
+	r3/posix/RTTimeNow-posix.cpp \
+	r3/posix/RTTimeSet-posix.cpp \
+	r3/posix/dir-posix.cpp \
+	r3/posix/env-posix.cpp \
+	r3/posix/errvars-posix.cpp \
+	r3/posix/fileio-posix.cpp \
+	r3/posix/fileio2-posix.cpp \
+	r3/posix/filelock-posix.cpp \
+	r3/posix/fs-posix.cpp \
+	r3/posix/fs2-posix.cpp \
+	r3/posix/fs3-posix.cpp \
+	r3/posix/ldrNative-posix.cpp \
+	r3/posix/rtmempage-exec-mmap-heap-posix.cpp \
+	r3/posix/path-posix.cpp \
+	r3/posix/path2-posix.cpp \
+	r3/posix/pathhost-posix.cpp \
+	r3/posix/RTPathUserDocuments-posix.cpp \
+	r3/posix/pipe-posix.cpp \
+	r3/posix/process-posix.cpp \
+	r3/posix/process-creation-posix.cpp \
+	r3/posix/rand-posix.cpp \
+	r3/posix/semevent-posix.cpp \
+	r3/posix/semeventmulti-posix.cpp \
+	r3/posix/semmutex-posix.cpp \
+	r3/posix/semrw-posix.cpp \
+	r3/posix/symlink-posix.cpp \
+	r3/posix/thread-posix.cpp \
+	r3/posix/thread2-posix.cpp \
+	r3/posix/time-posix.cpp \
+	r3/posix/timelocal-posix.cpp \
+	r3/posix/timer-posix.cpp \
+	r3/posix/tls-posix.cpp \
+	r3/posix/utf8-posix.cpp
+
 RuntimeR3_SOURCES.solaris = \
 	generic/cdrom-generic.cpp \
 	generic/RTDirQueryInfo-generic.cpp \
@@ -1351,6 +1420,8 @@ VBoxRT_LIBS.darwin             = \
 VBoxRT_LIBS.freebsd            = \
 	iconv \
 	rt
+VBoxRT_LIBS.netbsd             = \
+	rt
 VBoxRT_LIBS.haiku              = \
 	iconv
 VBoxRT_LIBS.solaris            = \
@@ -1453,6 +1524,8 @@ VBoxRT-x86_LIBS.darwin             = \
 VBoxRT-x86_LIBS.freebsd            = \
 	iconv \
 	rt
+VBoxRT-x86_LIBS.netbsd             = \
+	rt
 VBoxRT-x86_LIBS.haiku              = \
 	iconv
 VBoxRT-x86_LIBS.solaris            = \
@@ -1628,7 +1701,7 @@ RuntimeR0_SOURCES      := \
 	\
 	$(RuntimeNoCrt_SOURCES)
 
-if1of ($(KBUILD_TARGET), darwin solaris freebsd)
+if1of ($(KBUILD_TARGET), darwin solaris freebsd netbsd)
 RuntimeR0_SOURCES += \
 	common/math/gcc/adddi3.c \
 	common/math/gcc/anddi3.c \
@@ -1682,7 +1755,6 @@ RuntimeR0_SOURCES.win = \
 RuntimeR0_SOURCES.os2 = \
 	os2/sys0.asm
 
-
 #
 # RuntimeR0Stub - Ring-0 context startup stub for Windows and Solaris.
 #
@@ -2122,6 +2194,38 @@ RuntimeR0Drv_SOURCES.freebsd = \
 	r0drv/memobj-r0drv.cpp \
 	r0drv/powernotification-r0drv.c
 
+RuntimeR0Drv_SOURCES.netbsd = \
+	common/misc/thread.cpp \
+	common/string/memchr.asm \
+	common/string/memmove.asm \
+	common/string/memcmp.asm \
+	common/string/strchr.asm \
+	generic/RTAssertShouldPanic-generic.cpp \
+	generic/RTLogWriteDebugger-generic.cpp \
+	generic/RTLogWriteStdOut-stub-generic.cpp \
+	generic/RTTimerCreate-generic.cpp \
+	generic/mppresent-generic.cpp \
+	r0drv/generic/RTMpIsCpuWorkPending-r0drv-generic.cpp \
+	r0drv/generic/mpnotification-r0drv-generic.cpp \
+	r0drv/generic/threadctxhooks-r0drv-generic.cpp \
+	r0drv/netbsd/alloc-r0drv-netbsd.c \
+	r0drv/netbsd/assert-r0drv-netbsd.c \
+	r0drv/netbsd/initterm-r0drv-netbsd.c \
+	r0drv/netbsd/memobj-r0drv-netbsd.c \
+	r0drv/netbsd/memuserkernel-r0drv-netbsd.c \
+	r0drv/netbsd/process-r0drv-netbsd.c \
+	r0drv/netbsd/semevent-r0drv-netbsd.c \
+	r0drv/netbsd/semeventmulti-r0drv-netbsd.c \
+	r0drv/netbsd/semfastmutex-r0drv-netbsd.c \
+	r0drv/netbsd/spinlock-r0drv-netbsd.c \
+	r0drv/netbsd/thread-r0drv-netbsd.c \
+	r0drv/netbsd/thread2-r0drv-netbsd.c \
+	r0drv/netbsd/time-r0drv-netbsd.c \
+	r0drv/netbsd/mp-r0drv-netbsd.c \
+	generic/timer-generic.cpp \
+	r0drv/memobj-r0drv.cpp \
+	r0drv/powernotification-r0drv.c
+
 RuntimeR0Drv_SOURCES.solaris = \
 	common/misc/thread.cpp \
 	common/string/memchr.asm \
@@ -2194,7 +2298,6 @@ RuntimeR0Drv_ORDERDEPS.freebsd = \
 	$(PATH_STAGE)/gen-sys-hdrs/bus_if.h \
 	$(PATH_STAGE)/gen-sys-hdrs/device_if.h
 
-
 #
 # RuntimeGuestR0 - Guest driver runtime.
 #                  This is almost the same as the RuntimeR0Drv, the main difference
@@ -2477,7 +2580,6 @@ $$(FreeBSDGeneratedKernelHeaders_0_OUTDIR)/pci_if.h: $(VBOX_FREEBSD_SRC)/dev/pci
 	$(QUIET)$(RM) $(@D)/pci_if.m
 endif # FreeBSD
 
-
 #
 # Aliases for .cpp.h files so we can more easily do syntax checking from the editor.
 #
diff --git src/VBox/Runtime/r0drv/netbsd/alloc-r0drv-netbsd.c src/VBox/Runtime/r0drv/netbsd/alloc-r0drv-netbsd.c
new file mode 100644
index 0000000..f781fe3
--- /dev/null
+++ src/VBox/Runtime/r0drv/netbsd/alloc-r0drv-netbsd.c
@@ -0,0 +1,117 @@
+/*******************************************************************************
+*   Header Files                                                               *
+*******************************************************************************/
+#include "the-netbsd-kernel.h"
+#include "internal/iprt.h"
+#include <iprt/mem.h>
+
+#include <iprt/assert.h>
+#include <iprt/err.h>
+#include <iprt/param.h>
+
+#include "r0drv/alloc-r0drv.h"
+
+
+DECLHIDDEN(int) rtR0MemAllocEx(size_t cb, uint32_t fFlags, PRTMEMHDR *ppHdr)
+{
+    size_t      cbAllocated = cb;
+    PRTMEMHDR   pHdr        = NULL;
+
+    {
+        if (fFlags & RTMEMHDR_FLAG_ZEROED) {
+            pHdr = kmem_zalloc(cb + sizeof(RTMEMHDR), KM_NOSLEEP);
+        } else {
+            pHdr = kmem_alloc(cb + sizeof(RTMEMHDR), KM_NOSLEEP);
+        }
+    }
+
+    if (RT_UNLIKELY(!pHdr))
+        return VERR_NO_MEMORY;
+
+    pHdr->u32Magic   = RTMEMHDR_MAGIC;
+    pHdr->fFlags     = fFlags;
+    pHdr->cb         = cbAllocated;
+    pHdr->cbReq      = cb;
+
+    *ppHdr = pHdr;
+    return VINF_SUCCESS;
+}
+
+
+DECLHIDDEN(void) rtR0MemFree(PRTMEMHDR pHdr)
+{
+    pHdr->u32Magic += 1;
+
+    kmem_free(pHdr, pHdr->cb + sizeof(RTMEMHDR));
+}
+
+RTR0DECL(void) RTMemContFree(void *pv, size_t cb)
+{
+    if (pv)
+    {
+        cb = round_page(cb);
+
+        paddr_t pa;
+        pmap_extract(pmap_kernel(), (vaddr_t)pv, &pa);
+
+        /*
+         * Reconstruct pglist to free the physical pages
+         */
+        struct pglist rlist;
+        TAILQ_INIT(&rlist);
+
+        for (paddr_t pa2 = pa ; pa2 < pa + cb ; pa2 += PAGE_SIZE) {
+            struct vm_page *page = PHYS_TO_VM_PAGE(pa2);
+            TAILQ_INSERT_TAIL(&rlist, page, pageq.queue);
+        }
+
+        /* Unmap */
+        pmap_kremove((vaddr_t)pv, cb);
+
+        /* Free the virtual space */
+        uvm_km_free(kernel_map, (vaddr_t)pv, cb, UVM_KMF_VAONLY);
+
+        /* Free the physical pages */
+        uvm_pglistfree(&rlist);
+    }
+}
+
+RTR0DECL(void *) RTMemContAlloc(PRTCCPHYS pPhys, size_t cb)
+{
+    /*
+     * Validate input.
+     */
+    AssertPtr(pPhys);
+    Assert(cb > 0);
+
+    cb = round_page(cb);
+
+    vaddr_t virt = uvm_km_alloc(kernel_map, cb, 0,
+            UVM_KMF_VAONLY | UVM_KMF_WAITVA | UVM_KMF_CANFAIL);
+    if (virt == 0) {
+        return NULL;
+    }
+
+    struct pglist rlist;
+
+    if (uvm_pglistalloc(cb, 0, (paddr_t)0xFFFFFFFF,
+            PAGE_SIZE, 0, &rlist, 1, 1) != 0) {
+        uvm_km_free(kernel_map, virt, cb, UVM_KMF_VAONLY);
+        return NULL;
+    }
+
+    struct vm_page *page;
+    vaddr_t virt2 = virt;
+    TAILQ_FOREACH(page, &rlist, pageq.queue)
+    {
+        pmap_kenter_pa(virt2, VM_PAGE_TO_PHYS(page),
+                VM_PROT_READ | VM_PROT_WRITE | VM_PROT_EXECUTE, 0);
+        virt2 += PAGE_SIZE;
+    }
+
+    page = TAILQ_FIRST(&rlist);
+    *pPhys = VM_PAGE_TO_PHYS(page);
+
+    return (void *)virt;
+
+}
diff --git src/VBox/Runtime/r0drv/netbsd/assert-r0drv-netbsd.c src/VBox/Runtime/r0drv/netbsd/assert-r0drv-netbsd.c
new file mode 100644
index 0000000..d048272
--- /dev/null
+++ src/VBox/Runtime/r0drv/netbsd/assert-r0drv-netbsd.c
@@ -0,0 +1,62 @@
+/* $Id: assert-r0drv-netbsd.c $ */
+/** @file
+ * IPRT - Assertion Workers, Ring-0 Drivers, NetBSD.
+ */
+
+/*
+ * Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+ *
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ *
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ */
+
+/*******************************************************************************
+*   Header Files                                                               *
+*******************************************************************************/
+#include "the-netbsd-kernel.h"
+
+#include <iprt/assert.h>
+#include <iprt/log.h>
+#include <iprt/stdarg.h>
+
+#include "internal/assert.h"
+
+
+DECLHIDDEN(void) rtR0AssertNativeMsg1(const char *pszExpr, unsigned uLine, const char *pszFile, const char *pszFunction)
+{
+    printf("\r\n!!Assertion Failed!!\r\n"
+           "Expression: %s\r\n"
+           "Location  : %s(%d) %s\r\n",
+           pszExpr, pszFile, uLine, pszFunction);
+}
+
+
+DECLHIDDEN(void) rtR0AssertNativeMsg2V(bool fInitial, const char *pszFormat, va_list va)
+{
+    /** @todo implement rtR0AssertNativeMsg2V. */
+}
+
+
+RTR0DECL(void) RTR0AssertPanicSystem(void)
+{
+    panic("%s%s", g_szRTAssertMsg1, g_szRTAssertMsg2);
+
+}
diff --git src/VBox/Runtime/r0drv/netbsd/initterm-r0drv-netbsd.c src/VBox/Runtime/r0drv/netbsd/initterm-r0drv-netbsd.c
new file mode 100644
index 0000000..f2ad115
--- /dev/null
+++ src/VBox/Runtime/r0drv/netbsd/initterm-r0drv-netbsd.c
@@ -0,0 +1,52 @@
+/* $Id: initterm-r0drv-netbsd.c $ */
+/** @file
+ * IPRT - Initialization & Termination, Ring-0 Driver, NetBSD.
+ */
+
+/*
+ * Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+ *
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ *
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ */
+
+/*******************************************************************************
+*   Header Files                                                               *
+*******************************************************************************/
+#include "the-netbsd-kernel.h"
+
+#include <iprt/err.h>
+
+#include "internal/initterm.h"
+
+
+DECLHIDDEN(int) rtR0InitNative(void)
+{
+    /* nothing to do */
+    return VINF_SUCCESS;
+}
+
+
+DECLHIDDEN(void) rtR0TermNative(void)
+{
+    /* nothing to undo */
+}
+
diff --git src/VBox/Runtime/r0drv/netbsd/memobj-r0drv-netbsd.c src/VBox/Runtime/r0drv/netbsd/memobj-r0drv-netbsd.c
new file mode 100644
index 0000000..060db9b
--- /dev/null
+++ src/VBox/Runtime/r0drv/netbsd/memobj-r0drv-netbsd.c
@@ -0,0 +1,519 @@
+/* $Id: memobj-r0drv-freebsd.c $ */
+/** @file
+ * IPRT - Ring-0 Memory Objects, NetBSD.
+ */
+
+/*******************************************************************************
+*   Header Files                                                               *
+*******************************************************************************/
+#include "the-netbsd-kernel.h"
+
+#include <iprt/memobj.h>
+#include <iprt/mem.h>
+#include <iprt/err.h>
+#include <iprt/assert.h>
+#include <iprt/log.h>
+#include <iprt/param.h>
+#include <iprt/process.h>
+#include "internal/memobj.h"
+
+
+/*******************************************************************************
+*   Structures and Typedefs                                                    *
+*******************************************************************************/
+/**
+ * The NetBSD version of the memory object structure.
+ */
+typedef struct RTR0MEMOBJNETBSD
+{
+    /** The core structure. */
+    RTR0MEMOBJINTERNAL  Core;
+    size_t              size;
+    struct pglist       pglist;
+} RTR0MEMOBJNETBSD, *PRTR0MEMOBJNETBSD;
+
+
+typedef struct vm_map* vm_map_t;
+
+/**
+ * Gets the virtual memory map the specified object is mapped into.
+ *
+ * @returns VM map handle on success, NULL if no map.
+ * @param   pMem                The memory object.
+ */
+static vm_map_t rtR0MemObjNetBSDGetMap(PRTR0MEMOBJINTERNAL pMem)
+{
+    switch (pMem->enmType)
+    {
+        case RTR0MEMOBJTYPE_PAGE:
+        case RTR0MEMOBJTYPE_LOW:
+        case RTR0MEMOBJTYPE_CONT:
+            return kernel_map;
+
+        case RTR0MEMOBJTYPE_PHYS:
+        case RTR0MEMOBJTYPE_PHYS_NC:
+            return NULL; /* pretend these have no mapping atm. */
+
+        case RTR0MEMOBJTYPE_LOCK:
+            return pMem->u.Lock.R0Process == NIL_RTR0PROCESS
+                ? kernel_map
+                : &((struct proc *)pMem->u.Lock.R0Process)->p_vmspace->vm_map;
+
+        case RTR0MEMOBJTYPE_RES_VIRT:
+            return pMem->u.ResVirt.R0Process == NIL_RTR0PROCESS
+                ? kernel_map
+                : &((struct proc *)pMem->u.ResVirt.R0Process)->p_vmspace->vm_map;
+
+        case RTR0MEMOBJTYPE_MAPPING:
+            return pMem->u.Mapping.R0Process == NIL_RTR0PROCESS
+                ? kernel_map
+                : &((struct proc *)pMem->u.Mapping.R0Process)->p_vmspace->vm_map;
+
+        default:
+            return NULL;
+    }
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeFree(RTR0MEMOBJ pMem)
+{
+    PRTR0MEMOBJNETBSD pMemNetBSD = (PRTR0MEMOBJNETBSD)pMem;
+    int rc;
+
+    switch (pMemNetBSD->Core.enmType)
+    {
+        case RTR0MEMOBJTYPE_PAGE:
+        {
+            kmem_free(pMemNetBSD->Core.pv, pMemNetBSD->Core.cb);
+            break;
+        }
+        case RTR0MEMOBJTYPE_LOW:
+        case RTR0MEMOBJTYPE_CONT:
+        {
+            /* Unmap */
+            pmap_kremove((vaddr_t)pMemNetBSD->Core.pv, pMemNetBSD->Core.cb);
+            /* Free the virtual space */
+            uvm_km_free(kernel_map, (vaddr_t)pMemNetBSD->Core.pv, pMemNetBSD->Core.cb, UVM_KMF_VAONLY);
+            /* Free the physical pages */
+            uvm_pglistfree(&pMemNetBSD->pglist);
+            break;
+        }
+        case RTR0MEMOBJTYPE_PHYS:
+        case RTR0MEMOBJTYPE_PHYS_NC:
+        {
+            /* Free the physical pages */
+            uvm_pglistfree(&pMemNetBSD->pglist);
+            break;
+        }
+        case RTR0MEMOBJTYPE_LOCK:
+            if (pMemNetBSD->Core.u.Lock.R0Process != NIL_RTR0PROCESS) {
+                uvm_map_pageable(
+                        &((struct proc *)pMemNetBSD->Core.u.Lock.R0Process)->p_vmspace->vm_map,
+                        (vaddr_t)pMemNetBSD->Core.pv,
+                        ((vaddr_t)pMemNetBSD->Core.pv) + pMemNetBSD->Core.cb,
+                        1, 0);
+            }
+            break;
+        case RTR0MEMOBJTYPE_RES_VIRT:
+            if (pMemNetBSD->Core.u.Lock.R0Process == NIL_RTR0PROCESS) {
+                uvm_km_free(kernel_map, (vaddr_t)pMemNetBSD->Core.pv, pMemNetBSD->Core.cb, UVM_KMF_VAONLY);
+            }
+            break;
+        case RTR0MEMOBJTYPE_MAPPING:
+            if (pMemNetBSD->Core.u.Lock.R0Process == NIL_RTR0PROCESS) {
+                pmap_kremove((vaddr_t)pMemNetBSD->Core.pv, pMemNetBSD->Core.cb);
+                uvm_km_free(kernel_map, (vaddr_t)pMemNetBSD->Core.pv, pMemNetBSD->Core.cb, UVM_KMF_VAONLY);
+            }
+            break;
+
+        default:
+            AssertMsgFailed(("enmType=%d\n", pMemNetBSD->Core.enmType));
+            return VERR_INTERNAL_ERROR;
+    }
+
+    return VINF_SUCCESS;
+}
+
+static int rtR0MemObjNetBSDAllocHelper(PRTR0MEMOBJNETBSD pMemNetBSD, size_t cb, bool fExecutable,
+                                         paddr_t VmPhysAddrHigh, bool fContiguous)
+{
+    /* Virtual space first */
+    vaddr_t virt = uvm_km_alloc(kernel_map, cb, 0,
+            UVM_KMF_VAONLY | UVM_KMF_WAITVA | UVM_KMF_CANFAIL);
+    if (virt == 0) {
+        return VERR_NO_MEMORY;
+    }
+
+    struct pglist *rlist = &pMemNetBSD->pglist;
+
+    int nsegs = fContiguous ? 1 : INT_MAX;
+
+    /* Physical pages */
+    if (uvm_pglistalloc(cb, 0, VmPhysAddrHigh,
+            PAGE_SIZE, 0, rlist, nsegs, 1) != 0) {
+        uvm_km_free(kernel_map, virt, cb, UVM_KMF_VAONLY);
+        return VERR_NO_MEMORY;
+    }
+
+    /* Map */
+    struct vm_page *page;
+    vm_prot_t prot = VM_PROT_READ | VM_PROT_WRITE;
+    if (fExecutable) {
+        prot |= VM_PROT_EXECUTE;
+    }
+    vaddr_t virt2 = virt;
+    TAILQ_FOREACH(page, rlist, pageq.queue)
+    {
+        pmap_kenter_pa(virt2, VM_PAGE_TO_PHYS(page), prot, 0);
+        virt2 += PAGE_SIZE;
+    }
+
+    pMemNetBSD->Core.pv = (void *)virt;
+    if (fContiguous) {
+        page = TAILQ_FIRST(rlist);
+        pMemNetBSD->Core.u.Cont.Phys = VM_PAGE_TO_PHYS(page);
+    }
+    return VINF_SUCCESS;
+}
+
+DECLHIDDEN(int) rtR0MemObjNativeAllocPage(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, bool fExecutable)
+{
+    PRTR0MEMOBJNETBSD pMemNetBSD = (PRTR0MEMOBJNETBSD)rtR0MemObjNew(sizeof(*pMemNetBSD),
+                                                                       RTR0MEMOBJTYPE_PAGE, NULL, cb);
+    if (!pMemNetBSD)
+        return VERR_NO_MEMORY;
+
+    void *pvMem = kmem_alloc(cb, KM_SLEEP);
+    if (RT_UNLIKELY(!pvMem))
+    {
+        rtR0MemObjDelete(&pMemNetBSD->Core);
+        return VERR_NO_PAGE_MEMORY;
+    }
+    if (fExecutable) {
+        pmap_protect(pmap_kernel(), (vaddr_t)pvMem, ((vaddr_t)pvMem) + cb,
+                VM_PROT_READ | VM_PROT_WRITE | VM_PROT_EXECUTE);
+    }
+
+    pMemNetBSD->Core.pv = pvMem;
+    *ppMem = &pMemNetBSD->Core;
+    return VINF_SUCCESS;
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeAllocLow(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, bool fExecutable)
+{
+    PRTR0MEMOBJNETBSD pMemNetBSD = (PRTR0MEMOBJNETBSD)rtR0MemObjNew(sizeof(*pMemNetBSD),
+                                                                       RTR0MEMOBJTYPE_LOW, NULL, cb);
+    if (!pMemNetBSD)
+        return VERR_NO_MEMORY;
+
+    int rc = rtR0MemObjNetBSDAllocHelper(pMemNetBSD, cb, fExecutable, _4G - 1, false);
+    if (rc)
+    {
+        rtR0MemObjDelete(&pMemNetBSD->Core);
+        return rc;
+    }
+
+    *ppMem = &pMemNetBSD->Core;
+    return VINF_SUCCESS;
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeAllocCont(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, bool fExecutable)
+{
+    PRTR0MEMOBJNETBSD pMemNetBSD = (PRTR0MEMOBJNETBSD)rtR0MemObjNew(sizeof(*pMemNetBSD),
+                                                                       RTR0MEMOBJTYPE_CONT, NULL, cb);
+    if (!pMemNetBSD)
+        return VERR_NO_MEMORY;
+
+    int rc = rtR0MemObjNetBSDAllocHelper(pMemNetBSD, cb, fExecutable, _4G - 1, true);
+    if (rc)
+    {
+        rtR0MemObjDelete(&pMemNetBSD->Core);
+        return rc;
+    }
+
+    *ppMem = &pMemNetBSD->Core;
+    return VINF_SUCCESS;
+}
+
+
+static int rtR0MemObjNetBSDAllocPhysPages(PPRTR0MEMOBJINTERNAL ppMem, RTR0MEMOBJTYPE enmType,
+                                           size_t cb,
+                                           RTHCPHYS PhysHighest, size_t uAlignment,
+                                           bool fContiguous)
+{
+    paddr_t VmPhysAddrHigh;
+
+    /* create the object. */
+    PRTR0MEMOBJNETBSD pMemNetBSD = (PRTR0MEMOBJNETBSD)rtR0MemObjNew(sizeof(*pMemNetBSD),
+                                                                       enmType, NULL, cb);
+    if (!pMemNetBSD)
+        return VERR_NO_MEMORY;
+
+    if (PhysHighest != NIL_RTHCPHYS)
+        VmPhysAddrHigh = PhysHighest;
+    else
+        VmPhysAddrHigh = ~(paddr_t)0;
+
+    int nsegs = fContiguous ? 1 : INT_MAX;
+
+    int error = uvm_pglistalloc(cb, 0, VmPhysAddrHigh, uAlignment, 0, &pMemNetBSD->pglist, nsegs, 1);
+    if (error) {
+        rtR0MemObjDelete(&pMemNetBSD->Core);
+        return VERR_NO_MEMORY;
+    }
+
+    if (fContiguous)
+    {
+        Assert(enmType == RTR0MEMOBJTYPE_PHYS);
+        const struct vm_page * const pg = TAILQ_FIRST(&pMemNetBSD->pglist);
+        pMemNetBSD->Core.u.Phys.PhysBase = VM_PAGE_TO_PHYS(pg);
+        pMemNetBSD->Core.u.Phys.fAllocated = true;
+    }
+    *ppMem = &pMemNetBSD->Core;
+
+    return VINF_SUCCESS;
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeAllocPhys(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, RTHCPHYS PhysHighest, size_t uAlignment)
+{
+    return rtR0MemObjNetBSDAllocPhysPages(ppMem, RTR0MEMOBJTYPE_PHYS, cb, PhysHighest, uAlignment, true);
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeAllocPhysNC(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, RTHCPHYS PhysHighest)
+{
+    return rtR0MemObjNetBSDAllocPhysPages(ppMem, RTR0MEMOBJTYPE_PHYS_NC, cb, PhysHighest, PAGE_SIZE, false);
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeEnterPhys(PPRTR0MEMOBJINTERNAL ppMem, RTHCPHYS Phys, size_t cb, uint32_t uCachePolicy)
+{
+    AssertReturn(uCachePolicy == RTMEM_CACHE_POLICY_DONT_CARE, VERR_NOT_SUPPORTED);
+
+    /* create the object. */
+    PRTR0MEMOBJNETBSD pMemNetBSD = (PRTR0MEMOBJNETBSD)rtR0MemObjNew(sizeof(*pMemNetBSD), RTR0MEMOBJTYPE_PHYS, NULL, cb);
+    if (!pMemNetBSD)
+        return VERR_NO_MEMORY;
+
+    /* there is no allocation here, it needs to be mapped somewhere first. */
+    pMemNetBSD->Core.u.Phys.fAllocated = false;
+    pMemNetBSD->Core.u.Phys.PhysBase = Phys;
+    pMemNetBSD->Core.u.Phys.uCachePolicy = uCachePolicy;
+    TAILQ_INIT(&pMemNetBSD->pglist);
+    *ppMem = &pMemNetBSD->Core;
+    return VINF_SUCCESS;
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeLockUser(PPRTR0MEMOBJINTERNAL ppMem, RTR3PTR R3Ptr, size_t cb, uint32_t fAccess, RTR0PROCESS R0Process)
+{
+    PRTR0MEMOBJNETBSD pMemNetBSD = (PRTR0MEMOBJNETBSD)rtR0MemObjNew(sizeof(*pMemNetBSD), RTR0MEMOBJTYPE_LOCK, (void *)R3Ptr, cb);
+    if (!pMemNetBSD)
+        return VERR_NO_MEMORY;
+
+    int rc = uvm_map_pageable(
+            &((struct proc *)R0Process)->p_vmspace->vm_map,
+            R3Ptr,
+            R3Ptr + cb,
+            0, 0);
+    if (rc) {
+        rtR0MemObjDelete(&pMemNetBSD->Core);
+        return VERR_NO_MEMORY;
+    }
+
+    pMemNetBSD->Core.u.Lock.R0Process = R0Process;
+    *ppMem = &pMemNetBSD->Core;
+    return VINF_SUCCESS;
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeLockKernel(PPRTR0MEMOBJINTERNAL ppMem, void *pv, size_t cb, uint32_t fAccess)
+{
+    /* Kernel memory (always?) wired; all memory allocated by vbox code is? */
+    PRTR0MEMOBJNETBSD pMemNetBSD = (PRTR0MEMOBJNETBSD)rtR0MemObjNew(sizeof(*pMemNetBSD), RTR0MEMOBJTYPE_LOCK, pv, cb);
+    if (!pMemNetBSD)
+        return VERR_NO_MEMORY;
+
+    pMemNetBSD->Core.u.Lock.R0Process = NIL_RTR0PROCESS;
+    pMemNetBSD->Core.pv = pv;
+    *ppMem = &pMemNetBSD->Core;
+    return VINF_SUCCESS;
+}
+
+DECLHIDDEN(int) rtR0MemObjNativeReserveKernel(PPRTR0MEMOBJINTERNAL ppMem, void *pvFixed, size_t cb, size_t uAlignment)
+{
+    if (pvFixed != (void *)-1) {
+        /* can we support this? or can we assume the virtual space is already reserved? */
+        printf("reserve specified kernel virtual address not supported\n");
+        return VERR_NOT_SUPPORTED;
+    }
+
+    PRTR0MEMOBJNETBSD pMemNetBSD = (PRTR0MEMOBJNETBSD)rtR0MemObjNew(sizeof(*pMemNetBSD), RTR0MEMOBJTYPE_RES_VIRT, NULL, cb);
+    if (!pMemNetBSD)
+        return VERR_NO_MEMORY;
+
+    vaddr_t virt = uvm_km_alloc(kernel_map, cb, uAlignment,
+            UVM_KMF_VAONLY | UVM_KMF_WAITVA | UVM_KMF_CANFAIL);
+    if (virt == 0) {
+        rtR0MemObjDelete(&pMemNetBSD->Core);
+        return VERR_NO_MEMORY;
+    }
+
+    pMemNetBSD->Core.u.ResVirt.R0Process = NIL_RTR0PROCESS;
+    pMemNetBSD->Core.pv = (void *)virt;
+    *ppMem = &pMemNetBSD->Core;
+    return VINF_SUCCESS;
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeReserveUser(PPRTR0MEMOBJINTERNAL ppMem, RTR3PTR R3PtrFixed, size_t cb, size_t uAlignment, RTR0PROCESS R0Process)
+{
+    printf("NativeReserveUser\n");
+    return VERR_NOT_SUPPORTED;
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeMapKernel(PPRTR0MEMOBJINTERNAL ppMem, RTR0MEMOBJ pMemToMap, void *pvFixed, size_t uAlignment,
+                                          unsigned fProt, size_t offSub, size_t cbSub)
+{
+    if (pvFixed != (void *)-1) {
+        /* can we support this? or can we assume the virtual space is already reserved? */
+        printf("map to specified kernel virtual address not supported\n");
+        return VERR_NOT_SUPPORTED;
+    }
+
+    PRTR0MEMOBJNETBSD pMemNetBSD0 = (PRTR0MEMOBJNETBSD)pMemToMap;
+    if ((pMemNetBSD0->Core.enmType != RTR0MEMOBJTYPE_PHYS)
+        && (pMemNetBSD0->Core.enmType != RTR0MEMOBJTYPE_PHYS_NC)) {
+        printf("memory to map is not physical\n");
+        return VERR_NOT_SUPPORTED;
+    }
+    size_t sz = cbSub > 0 ? cbSub : pMemNetBSD0->Core.cb;
+
+    PRTR0MEMOBJNETBSD pMemNetBSD = (PRTR0MEMOBJNETBSD)rtR0MemObjNew(sizeof(*pMemNetBSD), RTR0MEMOBJTYPE_MAPPING, NULL, sz);
+
+    vaddr_t virt = uvm_km_alloc(kernel_map, sz, uAlignment,
+            UVM_KMF_VAONLY | UVM_KMF_WAITVA | UVM_KMF_CANFAIL);
+    if (virt == 0) {
+        rtR0MemObjDelete(&pMemNetBSD->Core);
+        return VERR_NO_MEMORY;
+    }
+
+    vm_prot_t prot = 0;
+
+    if ((fProt & RTMEM_PROT_READ) == RTMEM_PROT_READ)
+        prot |= VM_PROT_READ;
+    if ((fProt & RTMEM_PROT_WRITE) == RTMEM_PROT_WRITE)
+        prot |= VM_PROT_WRITE;
+    if ((fProt & RTMEM_PROT_EXEC) == RTMEM_PROT_EXEC)
+        prot |= VM_PROT_EXECUTE;
+
+    struct vm_page *page;
+    vaddr_t virt2 = virt;
+    size_t map_pos = 0;
+    TAILQ_FOREACH(page, &pMemNetBSD0->pglist, pageq.queue)
+    {
+        if (map_pos >= offSub) {
+            if (cbSub > 0 && (map_pos >= offSub + cbSub)) {
+                break;
+            }
+            pmap_kenter_pa(virt2, VM_PAGE_TO_PHYS(page), prot, 0);
+            virt2 += PAGE_SIZE;
+        }
+        map_pos += PAGE_SIZE;
+    }
+
+    pMemNetBSD->Core.pv = (void *)virt;
+    pMemNetBSD->Core.u.Mapping.R0Process = NIL_RTR0PROCESS;
+    *ppMem = &pMemNetBSD->Core;
+
+    return VINF_SUCCESS;
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeMapUser(PPRTR0MEMOBJINTERNAL ppMem, RTR0MEMOBJ pMemToMap, RTR3PTR R3PtrFixed, size_t uAlignment,
+                                        unsigned fProt, RTR0PROCESS R0Process)
+{
+    printf("NativeMapUser\n");
+    return VERR_NOT_SUPPORTED;
+}
+
+
+DECLHIDDEN(int) rtR0MemObjNativeProtect(PRTR0MEMOBJINTERNAL pMem, size_t offSub, size_t cbSub, uint32_t fProt)
+{
+    vm_prot_t          ProtectionFlags = 0;
+    vaddr_t        AddrStart       = (vaddr_t)pMem->pv + offSub;
+    vm_map_t           pVmMap          = rtR0MemObjNetBSDGetMap(pMem);
+
+    if (!pVmMap)
+        return VERR_NOT_SUPPORTED;
+
+    if ((fProt & RTMEM_PROT_READ) == RTMEM_PROT_READ)
+        ProtectionFlags |= UVM_PROT_R;
+    if ((fProt & RTMEM_PROT_WRITE) == RTMEM_PROT_WRITE)
+        ProtectionFlags |= UVM_PROT_W;
+    if ((fProt & RTMEM_PROT_EXEC) == RTMEM_PROT_EXEC)
+        ProtectionFlags |= UVM_PROT_X;
+
+    int error = uvm_map_protect(pVmMap, AddrStart, AddrStart + cbSub,
+        ProtectionFlags, 0);
+    if (!error)
+        return VINF_SUCCESS;
+
+    return VERR_NOT_SUPPORTED;
+}
+
+
+DECLHIDDEN(RTHCPHYS) rtR0MemObjNativeGetPagePhysAddr(PRTR0MEMOBJINTERNAL pMem, size_t iPage)
+{
+    PRTR0MEMOBJNETBSD pMemNetBSD = (PRTR0MEMOBJNETBSD)pMem;
+
+    switch (pMemNetBSD->Core.enmType)
+    {
+        case RTR0MEMOBJTYPE_PAGE:
+        case RTR0MEMOBJTYPE_LOW:
+        {
+            vaddr_t va = (vaddr_t)pMemNetBSD->Core.pv + ptoa(iPage);
+            paddr_t pa = 0;
+            pmap_extract(pmap_kernel(), va, &pa);
+            return pa;
+        }
+        case RTR0MEMOBJTYPE_CONT:
+            return pMemNetBSD->Core.u.Cont.Phys + ptoa(iPage);
+        case RTR0MEMOBJTYPE_PHYS:
+            return pMemNetBSD->Core.u.Phys.PhysBase + ptoa(iPage);
+        case RTR0MEMOBJTYPE_PHYS_NC:
+        {
+            struct vm_page *page;
+            size_t i = 0;
+            TAILQ_FOREACH(page, &pMemNetBSD->pglist, pageq.queue)
+            {
+                if (i == iPage)
+                    break;
+                i++;
+            }
+            return VM_PAGE_TO_PHYS(page);
+        }
+        case RTR0MEMOBJTYPE_LOCK:
+        case RTR0MEMOBJTYPE_MAPPING:
+        {
+            pmap_t pmap;
+            if (pMem->u.Lock.R0Process == NIL_RTR0PROCESS) {
+                pmap = pmap_kernel();
+            } else {
+                pmap = ((struct proc *)pMem->u.Lock.R0Process)->p_vmspace->vm_map.pmap;
+            }
+            vaddr_t va = (vaddr_t)pMemNetBSD->Core.pv + ptoa(iPage);
+            paddr_t pa = 0;
+            pmap_extract(pmap, va, &pa);
+            return pa;
+        }
+        case RTR0MEMOBJTYPE_RES_VIRT:
+            return NIL_RTHCPHYS;
+        default:
+            return NIL_RTHCPHYS;
+    }
+}
